%define _buildid .66

%global py26nvr python26-botocore-%{version}-%{release}
%global py26builddir %{_builddir}/%{py26nvr}
%global py26doc ../%{py26nvr}

%global py27nvr python27-botocore-%{version}-%{release}
%global py27builddir %{_builddir}/%{py27nvr}
%global py27doc ../%{py27nvr}

%bcond_with integration_tests # without
%bcond_without tests          # with

%global upstream_name botocore
%global docutils_ver    0.10
%global jmespath_ver    0.9.2
%global dateutil_ver    2.1
%global simplejson_ver  3.6.5
%global ordereddict_ver 1.1
%global mock_ver        1.0.1
%global nose_ver        1.3.0

%global bundled_bcdoc_ver       0.16.0
%global bundled_requests_ver    2.7.0
%global bundled_six_ver         1.8.0

# bundled with requests
%global bundled_urllib3_ver     1.10.4
%global bundled_chardet_ver     2.3.0

# bundled with urllib3
%global bundled_urllib3_six_ver 1.2.0

Name: python-botocore
Version: 1.8.13
Release: 1%{?_buildid}%{?dist}
Summary: A low-level interface to a growing number of Amazon Web Services.
Group: Development/Languages
License: ASL 2.0
URL: https://github.com/boto/botocore
Source0: %{url}/archive/%{version}.tar.gz
Patch1: botocore-remove-guzzle-dependency.patch
Patch2: botocore-remove-ca-bundle.patch
Patch3: botocore-unvendor-ssl_match_hostname.patch
# This only patches botocore's test code, not user-facing code
Patch4: botocore-test-env.patch
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: python26
BuildRequires: python27

%description
Botocore is a low-level interface to a growing number of Amazon Web
Services. Botocore serves as the foundation for the AWS-CLI command
line utilities. It will also play an important role in the boto3.x
project.

%package -n python26-botocore
Summary: A low-level interface to a growing number of Amazon Web Services.
BuildRequires: python26-devel
# Versions taken from setup.py and requirements.txt
BuildRequires: python26-docutils >= %{docutils_ver}
BuildRequires: python26-jmespath = %{jmespath_ver}
BuildRequires: python26-dateutil >= %{dateutil_ver}
# Additional requirements for python 2.6
BuildRequires: python26-simplejson >= %{simplejson_ver}
BuildRequires: python26-ordereddict >= %{ordereddict_ver}
BuildRequires: python26-backports-ssl_match_hostname
# For testing
BuildRequires: python26-mock >= %{mock_ver}
BuildRequires: python26-nose >= %{nose_ver}
%if %{without integration_tests}
# Needed for the --exclude-dir flag on nose
BuildRequires: python26-nose-exclude
%endif
BuildRequires: python26-unittest2
# Runtime requirements
Requires: ca-certificates
Requires: python26-docutils >= %{docutils_ver}
Requires: python26-jmespath = %{jmespath_ver}
Requires: python26-dateutil >= %{dateutil_ver}
# Additional requirements for python-2.6
Requires: python26-simplejson >= %{simplejson_ver}
Requires: python26-ordereddict >= %{ordereddict_ver}
Requires: python26-backports-ssl_match_hostname
Provides: python-botocore = %{version}-%{release}
# The botocore team bundles these packages with botocore so while
# they are required there is no external dependency
Provides: bundled(python-bcdoc) = %{bundled_bcdoc_ver}
Provides: bundled(python-requests) = %{bundled_requests_ver}
Provides: bundled(python-six) = %{bundled_six_ver}

# bundled with requests
Provides: bundled(python-urllib3) = %{bundled_urllib3_ver}
Provides: bundled(python-chardet) = %{bundled_chardet_ver}

# bundled with urllib3
Provides: bundled(python-six) = %{bundled_urllib3_six_ver}
# ordered_dict.py from http://code.activestate.com/recipes/576693/, no versioning data
Provides: bundled(python-ordereddict)
Obsoletes: python-botocore <= 0.94.0-1.4.amzn1
Obsoletes: python-bcdoc <= 0.13.0-1.2.amzn1
Obsoletes: python26-bcdoc <= 0.16.0-1.9.amzn1

%description -n python26-botocore
Botocore is a low-level interface to a growing number of Amazon Web
Services. Botocore serves as the foundation for the AWS-CLI command
line utilities. It will also play an important role in the boto3.x
project.

This package is meant to be used with Python 2.6.

%package -n python27-botocore
Summary: A low-level interface to a growing number of Amazon Web Services.
BuildRequires: python27-devel
# Versions taken from setup.py and requirements.txt
BuildRequires: python27-docutils >= %{docutils_ver}
BuildRequires: python27-jmespath = %{jmespath_ver}
BuildRequires: python27-dateutil >= %{dateutil_ver}
# For testing
BuildRequires: python27-mock >= %{mock_ver}
BuildRequires: python27-nose >= %{nose_ver}
%if %{without integration_tests}
# Needed for the --exclude-dir flag on nose
BuildRequires: python27-nose-exclude
%endif
BuildRequires: python27-unittest2
# Runtime requirements
Requires: ca-certificates
Requires: python27-docutils >= %{docutils_ver}
Requires: python27-jmespath = %{jmespath_ver}
Requires: python27-dateutil >= %{dateutil_ver}
# Ensure we have ssl.match_hostname
Requires: python27 >= 2.7.9
# The botocore team bundles these packages with botocore so while
# they are required there is no external dependency
Provides: bundled(python-bcdoc) = %{bundled_bcdoc_ver}
Provides: bundled(python-requests) = %{bundled_requests_ver}
Provides: bundled(python-six) = %{bundled_six_ver}

# bundled with requests
Provides: bundled(python-urllib3) = %{bundled_urllib3_ver}
Provides: bundled(python-chardet) = %{bundled_chardet_ver}

# bundled with urllib3
Provides: bundled(python-six) = %{bundled_urllib3_six_ver}
# ordered_dict.py from http://code.activestate.com/recipes/576693/, no versioning data
Provides: bundled(python-ordereddict)
Obsoletes: python27-bcdoc <= 0.16.0-1.9.amzn1

%description -n python27-botocore
Botocore is a low-level interface to a growing number of Amazon Web
Services. Botocore serves as the foundation for the AWS-CLI command
line utilities. It will also play an important role in the boto3.x
project.

This package is meant to be used with Python 2.7.

%prep
%setup -q -n %{upstream_name}-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

# Unbundle the certificate bundle from mozilla in vendored requests.
rm -v %{upstream_name}/vendored/requests/cacert.pem

%build
rm -rf %{py26builddir}
mkdir -p %{py26builddir}
cp -a * %{py26builddir}
pushd %{py26builddir}
CFLAGS="$RPM_OPT_FLAGS" %{__python26} setup.py build 
popd

rm -rf %{py27builddir}
mkdir -p %{py27builddir}
cp -a * %{py27builddir}
pushd %{py27builddir}
CFLAGS="$RPM_OPT_FLAGS" %{__python27} setup.py build 
popd

%install
rm -rf %{buildroot}

pushd %{py26builddir}
%{__python26} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd

%__python26_shebang_path %{buildroot}%{python26_sitelib}/%{upstream_name}/vendored

pushd %{py27builddir}
%{__python27} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd

%__python27_shebang_path %{buildroot}%{python27_sitelib}/%{upstream_name}/vendored

%check
%if %{with tests}
pushd %{py26builddir}/tests
export PYTHONPATH=%{buildroot}%{python26_sitelib}
%{_bindir}/nosetests-2.6 \
%if %{without integration_tests}
    --exclude-dir=integration \
%endif
    %{nil}
popd
pushd %{py27builddir}/tests
export PYTHONPATH=%{buildroot}%{python27_sitelib}
%{_bindir}/nosetests-2.7 \
%if %{without integration_tests}
    --exclude-dir=integration \
%endif
    %{nil}
popd
%endif

%clean
rm -rf %{buildroot}
rm -rf %{py26builddir}
rm -rf %{py27builddir}

%files -n python26-botocore
%doc LICENSE.txt README.rst
%{python26_sitelib}/*

%files -n python27-botocore
%doc LICENSE.txt README.rst
%{python27_sitelib}/*

%changelog
* Tue Dec 19 2017 Heath Petty <hpetty@amazon.com>
- Update to 1.8.13

* Thu Aug 10 2017 Iliana Weller <iweller@amazon.com>
- Update to 1.5.95

* Tue May 9 2017 Heath Petty <hpetty@amazon.com>
- Update to 1.5.46

* Wed Dec 14 2016 Ian Weller <iweller@amazon.com>
- Update to 1.4.86

* Thu Nov 17 2016 Ian Weller <iweller@amazon.com>
- Update to 1.4.74

* Mon Aug 15 2016 Ian Weller <iweller@amazon.com>
- Update to 1.4.46

* Mon Jul 11 2016 Ian Weller <iweller@amazon.com>
- Update to 1.4.36

* Thu May 26 2016 Ian Weller <iweller@amazon.com>
- Update to 1.4.23

* Mon Feb 29 2016 Sean Kelly <seankell@amazon.com>
- Update to 1.3.30

* Tue Feb 2 2016 Ian Weller <iweller@amazon.com>
- Update to 1.3.23

* Thu Jan 14 2016 Heath Petty <hpetty@amazon.com>
- Update to 1.3.18

* Tue Dec 22 2015 Heath Petty <hpetty@amazon.com>
- Update to 1.3.15

* Tue Dec 15 2015 Ben Cressey <bcressey@amazon.com>
- obsolete standalone bcdoc module

* Mon Dec 7 2015 Ian Weller <iweller@amazon.com>
- Remove install-info scriptlets
- Update to 1.3.11

* Tue Oct 27 2015 Ian Weller <iweller@amazon.com>
- Update to 1.3.1

* Fri Oct 23 2015 Ian Weller <iweller@amazon.com>
- Re-enable leak tests
- Update to 1.3.0

* Fri Oct 9 2015 Ian Weller <iweller@amazon.com>
- Disable memory leak tests that attempt to hit instance metadata service for credentials
- Disable building man and info pages

* Thu Oct 8 2015 Ian Weller <iweller@amazon.com>
- Update to 1.2.10

* Fri Sep 25 2015 Ian Weller <iweller@amazon.com>
- Run tests against files installed in buildroot

* Thu Sep 24 2015 Ian Weller <iweller@amazon.com>
- Update to 1.2.5

* Fri Sep 4 2015 Ian Weller <iweller@amazon.com>
- Update to 1.2.0

* Wed Aug 12 2015 Ian Weller <iweller@amazon.com>
- Update to 1.1.8

* Tue Aug 11 2015 Ian Weller <iweller@amazon.com>
- Update to 1.1.7

* Tue Aug 4 2015 Ian Weller <iweller@amazon.com>
- Update to botocore 1.1.5

* Fri Jul 24 2015 Ian Weller <iweller@amazon.com>
- Update to botocore 1.1.3

* Mon Jul 13 2015 Sean Kelly <seankell@amazon.com>
- Update to botocore 1.1.1

* Tue Jul 7 2015 hpetty <hpetty@amazon.com>
- Update to botocore 1.0.1

* Mon Jun 15 2015 Jason Green <jasg@amazon.com>
- Update to botocore 1.0.0b3

* Wed Jun 10 2015 Jason Green <jasg@amazon.com>
- Update to botocore 1.0.0b1

* Mon Jun 1 2015 Jason Green <jasg@amazon.com>
- Update to botocore 1.0.0a3

* Fri May 22 2015 Jason Green <jasg@amazon.com>
- Update to botocore 1.0.0a1

* Wed May 13 2015 hpetty <hpetty@amazon.com>
-  Update to botocore 0.107.0

* Wed Apr 22 2015 Jason Green <jasg@amazon.com>
- Update jmespath required version
- Update to botocore 0.104.0

* Thu Apr 16 2015 Jason Green <jasg@amazon.com>
- Update to botocore 0.103.0

* Mon Mar 16 2015 hpetty <hpetty@amazon.com>
- Update to botocore 0.95.0

* Thu Mar 12 2015 Tom Kirchner <tjk@amazon.com>
- Update to botocore 0.94.0

* Tue Mar 3 2015 hpetty <hpetty@amazon.com>
- Update to 0.93.0 from upstream

* Wed Feb 4 2015 Ben Cressey <bcressey@amazon.com>
- Build for multiple pythons
